from __future__ import print_function
from sys import stdin

def printf(str, *args):
	print(str % args, end='')

cnt = 0	# 이동 횟수에 이용되는 전역변수
def moveHanoi(fromP,tempP,toP,ng):
	if n == 1:
		cnt += 1
		printf("%5d: 말뚝 %s에서 말뚝 %s로 원반 %d를 이동\n" % (cnt,fromP,toP,1))
	else:
		moveHanoi(fromP,toP,tempP,n-1)
		cnt += 1
		printf("%5d: 말뚝 %s에서 말뚝 %s로 원반 %d를 이동\n" %(cntP,fromP,toP,n) )
		moveHanoi(tempP,fromP,toP,n-1)

printf("input Hanoi number (exit : 음수 ) : ")
n = int(stdin.readline())

while n>0:
	moveHanoi('A','B','C',n)
	cnt = 0
	printf("input Hanoi number (exit : 음수 ) : ")
	n = int(stdin.readline())

stdin.readline()